#include "usgard.h"

Pile1 = TEXT_MEM        ;Number of bricks, Size of bricks
Pile2 = Pile1+11
Pile3 = Pile2+11
Temp =  Pile3+11            ;Pile XCoord, which brick, which size
PP =	Temp+5			;Picked piece
From =	PP+1
NoM =	From+1			;Number of moves
Counter =	NoM+2
PXCoord =	Counter+1
XCoord =	PXCoord+1
YCoord =	XCoord+1
CMode =		YCoord+1
Blocks =	CMode+1



.org 0

Title:
        .db " The Tower of Hanoi  ",0

Start:
        call CLEARLCD
        ld (iy+$0D),0
Notexist:
        ld hl,Pile1
        ld de,Pile1+1
        ld bc,50
        ld (hl),0
        ldir

Message:
	ld hl,$0000
	ld (CURSOR_ROW),hl
	set 3,(iy+$05)
	ld hl,&Title
	call D_ZT_STR
	res 3,(iy+$05)

DispBlocks:
	ld hl,51*256+27
	ld (CURSOR_X),hl
	ld hl,&Author
	call D_ZM_STR
	ld bc,57*256+27
	ld (CURSOR_X),bc
	call D_ZM_STR
	ld bc,11*256+1
	ld (CURSOR_X),bc
	call D_ZM_STR
	ld bc,29*256+1
	ld (CURSOR_X),bc
	call D_ZM_STR

	ld hl,$FD30
	ld d,h
	ld e,l
	ld a,%01111111
	ld (hl),a
	inc hl
	rlca
	ld (hl),a
	inc hl
	ex de,hl
	ld bc,14
	ldir

	ld de,$FDBF
	inc hl
	ld bc,16
	lddr

	ld hl,$FD40
	ld d,h
	ld e,l
	ld a,$80
	ld (hl),a
	inc hl
	rlca
	ld (hl),a
	inc hl
	ex de,hl
	ld bc,110
	ldir

	ld hl,$FE54
	ld d,h
	ld e,l
	ld a,%01111111
	ld (hl),a
	ld a,255
	inc hl
	ld (hl),a
	inc hl
	ld (hl),a
	inc hl
	ld a,%11111110
	ld (hl),a
	inc hl
	ex de,hl
	ld bc,4
	ldir

	ld hl,$FEFC
	ex de,hl
	ld bc,9
	lddr

	ld hl,$FE64
	ld d,h
	ld e,l
	ld a,%10000000
	ld (hl),a
	inc hl
	inc hl
	inc hl
	rlca
	ld (hl),a
	inc hl
	ex de,hl
	ld bc,4
	ldir

	ld hl,$FE60
	ld de,$FE70
	ld bc,128
	ldir

	ld a,3
	ld (Blocks),a
DispNumbers:
	ld hl,$14FB
	ld (CURSOR_X),hl
	ld c,2
	ld b,7
DNLoop
	ld a,(CURSOR_X)
	add a,4
	ld (CURSOR_X),a
	inc c
	ld a,c
	#fncall DM_A_DEC
	djnz DNLoop
	inc c
	ld a,(CURSOR_X)
	add a,6
	ld (CURSOR_X),a
	ld a,c
	#fncall DM_A_DEC
	
	ld hl,39*256+35
	ld (CURSOR_X),hl
	ld hl,&NormalTxt
	call D_ZM_STR
	ld a,(CURSOR_X)
	add a,7
	ld (CURSOR_X),a
	call D_ZM_STR

	ld a,(CMode)
	call &BigInvert

	ld a,(Blocks)
	call &Select

	call &Stupid2

MessageLoop:
	call &Stupid
MessageLoopB:
	call GET_KEY
	cp K_LEFT
	jr z,DecNoB
	cp K_DOWN
	jr z,SelectMode
	cp K_EXIT
	jp z,&Quit
	cp K_ENTER
	jr z,StartGame
	cp K_RIGHT
	jr nz,MessageLoopB

IncNoB:
	ld a,(Blocks)
	cp 10
	jr z,MessageLoopB
	inc a
	ld (Blocks),a
	dec a
Common:
	call &Select
	ld a,(Blocks)
	call &Select
	jr MessageLoopB

DecNoB:
	ld a,(Blocks)
	cp 3
	jr z,MessageLoopB
	dec a
	ld (Blocks),a
	inc a
	jr Common

SelectMode:
	call &Stupid
SelectModeLoop:
	call GET_KEY
	cp K_ENTER
	jr z,StartGame
	cp K_RIGHT
	jr z,SetMode
	cp K_UP
	jr z,MessageLoop
	cp K_EXIT
	jp z,&Quit
	cp K_LEFT
	jr nz,SelectModeLoop

SetMode:
	ld a,(CMode)
	call &BigInvert
	ld a,(CMode)
	xor 1
	ld (CMode),a
	call &BigInvert
	jr SelectModeLoop

StartGame
	ld a,(CMode)
	or a
	jr z,Begin
	jp &Puzzle

Begin:
	call CLEARLCD
	ld hl,Pile1
    ld a,(Blocks)
    ld (hl),a
    inc hl
    ld b,a
Loop:
    ld (hl),a
    dec a
    inc hl
    djnz Loop
Loopend:
	ld a,-23
	ld (PXCoord),a
    call &DrawFirst
        
Move:
	ld a,-23
	ld (PXCoord),a
	call GET_KEY
	cp K_EXIT
	jp z,&EndRound
	cp K_F1
	jr z,FromLeftRoutine
	cp K_F3
	jr z,FromMiddleRoutine
	cp K_F5
	jr nz,Move

FromRightRoutine:
	ld a,2
	jr FromRoutine

FromMiddleRoutine:
	ld a,1
	jr FromRoutine

FromLeftRoutine:
	ld a,0

FromRoutine:
	ld l,7
	ld b,a
	ld (From),a
	add a,a
	ld c,a
	add a,a
	ld d,a
	add a,c
	add a,b
	add a,3
	ld h,a
	ld (CURSOR_ROW),hl
	sub 3
	add a,d
	ld e,a
	ld d,0
	ld hl,Pile1
	add hl,de
	ld a,6
	call TX_CHARPUT
	ld c,(hl)
	xor a
	cp c
	jr z,MoveNot
	dec (hl)
	ld b,0
	add hl,bc
	ld a,(hl)
	ld (PP),a
	xor a
	ld (hl),a
	jr To
MoveNot:
	call &DrawFirst
	jr Move

To:
	call GET_KEY
	cp K_EXIT
	jp z,&EndRound
	cp K_F1
	jr z,ToLeftRoutine
	cp K_F3
	jr z,ToMiddleRoutine
	cp K_F5
	jr nz,To

ToRightRoutine:
	ld a,2
	jr ToRoutine

ToMiddleRoutine:
	ld a,1
	jr ToRoutine

ToLeftRoutine:
	ld a,0


ToRoutine:
	ld b,a
	ld a,(From)
	cp b
	jr z,CouldntMove
	ld a,b
	add a,a
	add a,b
	add a,a
	add a,a
	sub b
	ld e,a
	ld d,0
	ld hl,Pile1
	add hl,de
	ld d,h
	ld e,l
	ld c,(hl)
	xor a
	cp c
	jr nz,NotZ
	inc hl
NotZ:
	ld b,0
	add hl,bc
	ld b,(hl)
	xor a
	cp b
	jr z,Zero
	ld a,(PP)
	cp b
	jr nc,CouldntMove
Zero:
	ld h,d
	ld l,e
	inc (hl)
	ld c,(hl)
	ld b,0
	add hl,bc
	ld a,(PP)
	ld (hl),a
	ld hl,(NoM)
	inc hl
	ld (NoM),hl
	call &DrawFirst

CheckDone:
	ld hl,Pile2
	ld a,(Blocks)
	ld b,(hl)
	cp b
	jr z,Done
	ld hl,Pile3
	ld a,(Blocks)
	ld b,(hl)
	cp b
	jr z,Done
	jp &Move

CouldntMove:
	ld a,(From)
	ld b,a
	add a,a
	add a,b
	add a,a
	add a,a
	sub b
	ld e,a
	ld d,0
	ld hl,Pile1
	add hl,de
CMRoutine:
	inc (hl)
	ld c,(hl)
	ld b,0
	add hl,bc
	ld a,(PP)
	ld (hl),a
	call &DrawFirst
	jp &Move

Done:
	ld hl,$0301
	ld (CURSOR_ROW),hl
	ld hl,&Congrats
	call D_ZT_STR
DoneLoop:
	halt
	call GET_KEY
	or a
	jr z,DoneLoop
	call CLEARLCD
	jp &Notexist

Puzzle:
	ld a,(Blocks)
	ld b,a
PuzzleLoop:
	call &Random
	ld e,a
	add a,a
	add a,e
	add a,a
	add a,a
	sub e
	ld e,a
	ld d,0
	ld hl,Pile1
	add hl,de
	inc (hl)
	ld e,(hl)
	add hl,de
	ld (hl),b	
	djnz PuzzleLoop
	jp &Loopend

EndRound:
	call CLEARLCD
	jp &Notexist

Select:
	sub 3
	add a,a
	ld e,a
	ld d,0
	ld hl,$FD40
	add hl,de
	ld de,15
	ld b,7
Invert:
	ld a,(hl)
	xor %01111111
	ld (hl),a
	inc hl
	ld a,(hl)
	xor %11111110
	ld (hl),a
	add hl,de
	djnz Invert
	ret


Random:
	ld a,3
	push bc
	push de
	push hl
	ld b,a
	ld a,r
	add a,a
	ld hl,0
	ld d,0
	ld e,a
RMul:
	add hl,de
	djnz RMul
	ld a,h
	pop hl
	pop de
	pop bc
	ret
	

DrawFirst:
	ld hl,GRAPH_MEM
	ld de,GRAPH_MEM+1
	ld (hl),0
	ld bc,1023
	ldir
	;call _clrLCD
        ld hl,Pile1-1
DrawPile1:
        ld a,0
        ld (Temp+1),a
        inc hl
        ld b,10
        ld a,(PXCoord)
        add a,43
        ld (PXCoord),a
DrawP1Loop:
        push bc
        ld a,(Temp+1)
        inc a
        ld (Temp+1),a
        inc hl
        ld a,(hl)
        push hl
        call &CheckSize
        pop hl
        pop bc
        djnz DrawP1Loop
        ld a,(Counter)
        inc a
        ld (Counter),a
        cp 3
        jr nz,DrawPile1

	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,1024
	ldir

Return:
	ld hl,(NoM)
	ld bc,$0101
	ld (CURSOR_X),bc
	call DM_HL_DECI
	xor a
	ld (Counter),a
	ld b,4
	ld hl,Temp
RetLoop:
	ld (hl),a
	inc hl
	djnz RetLoop

	ret

CheckSize:
        or a
        jr z,DrawPin

        ld (Temp+2),a
        ld a,(Temp+1)
		add a,a
		add a,a
	;ld b,a
        ;ld a,63
        ;sub b
	add a,12
        ld (YCoord),a
        jr PutItOut

DrawPin:
        ld a,(PXCoord)
        dec a
        ld (XCoord),a
        ld a,(Temp+1)
		add a,a
		add a,a
	;ld b,a
        ;ld a,63
        ;sub b
	add a,12
        ld (YCoord),a
        ld a,(YCoord)
        ld b,4
        sub b
        ld d,a
        ld (YCoord),a
        ld c,4
PinYLoop:        
        ld b,2
        ld a,(YCoord)
        dec a
        ld (YCoord),a
        ld a,(XCoord)
        ld e,a

PinXLoop:
        call &PutPixel
        inc e
        djnz PinXLoop
        dec c
        jr nz,PinYLoop
        ret
        
PutItOut:
        ld a,(Temp+2)
        add a,a
        ld b,a
        ld a,(PXCoord)
        sub b
        ld e,a
        ld (XCoord),a
        ld a,(YCoord)
        ld b,8
        sub b
        ld d,a
        ld (YCoord),a
        push de
        ld a,(Temp+2)
		add a,a
		add a,a
        ld b,a
        ld c,3
YLoop:
        ld a,(YCoord)
        inc a
        ld (YCoord),a
        ld a,(Temp+2)
	add a,a
	add a,a
        ld b,a
        ld a,(XCoord)
        ld e,a

XLoop:
        call &PutPixel
        inc e
        djnz XLoop
        dec c
        jr nz,YLoop
        pop de
        ret

PutPixel:
        push bc
	push de
        ld a,(YCoord)
        ld c,a
	ld b,e
        call FIND_PIXEL
	ld de,GRAPH_MEM
	add hl,de
        or (hl)
        ld (hl),a
	pop de
        pop bc
        ret

Quit:        
	set 1,(iy+$0D)
    	call CLEARTEXT
	ret



BigInvert:
	add a,a
	add a,a
	add a,4
	ld e,a
	ld d,0
	ld hl,$FE60
	add hl,de
	ld de,13
	ld b,9
BInvert:
	ld a,(hl)
	xor %01111111
	ld (hl),a
	inc hl
	ld a,(hl)
	cpl
	ld (hl),a
	inc hl
	ld a,(hl)
	cpl
	ld (hl),a
	inc hl
	ld a,(hl)
	xor %11111110
	ld (hl),a
	add hl,de
	djnz BInvert
	ret


Stupid:
	ld hl,$FCB0
	call &SelectWhat
Stupid2:
	ld hl,$FDD0
SelectWhat:
	ld de,12
	ld c,7
ThisLoop:
	ld b,4
SmthLoop:
	ld a,(hl)
	cpl
	ld (hl),a
	inc hl
	djnz SmthLoop
	add hl,de
	dec c
	jr nz,ThisLoop
	ret


NormalTxt:	.db "Normal",0
PuzzleTxt:	.db "Puzzle",0


Author:
	.db "Made by Andreas Finne",0
Email:
	.db "a_finne@hotmail.com",0

Numbertxt:	.db "Blocks:",0
Modetxt:	.db "Mode:",0

Congrats:	.db "Congratulations!",0

.end
